.486
.model flat, stdcall
option casemap :none

include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\kernel32.inc
include \masm32\macros\macros.asm
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\kernel32.lib

dw2asc proto :DWORD,:DWORD

printv MACRO varname:VARARG
    FOR arg,<varname>
        invoke StdOut,reparg(arg)
    ENDM        
ENDM

.data
    buffer db 30 dup(0)
.code
start:
    invoke dw2asc,0,addr buffer    
    printv addr buffer,SADD(13,10)
    invoke dw2asc,1,addr buffer    
    printv addr buffer,SADD(13,10)
    invoke dw2asc,-1,addr buffer    
    printv addr buffer,SADD(13,10)
    invoke dw2asc,7fffffffh,addr buffer    
    printv addr buffer,SADD(13,10)
    invoke dw2asc,80000000h,addr buffer    
    printv addr buffer,SADD(13,10)

    invoke StdIn,addr buffer,1    
    exit
; #########################################################################
; xmetal's code with altered entrance and exit, and one optimization.
; #########################################################################

dw2asc proc dwValue:DWORD, lpBuffer:DWORD

    push ebx                    ; (1)
    push esi                    ; (1)
    push edi                    ; (1)
    mov eax,dwValue             ; (1)
    mov edi,lpBuffer            ; (1)

    or  eax,eax                 ; (1)
    jnz @F                      ; (1)
    mov word ptr[edi],30h       ; (1)
    pop edi                     ; (1)
    pop esi                     ; (1)
    pop ebx                     ; (1)
    ret                         ; (2)
@@:
    jns @F                      ; (1)
    mov byte ptr[edi],'-'       ; (1)
    neg eax                     ; (1)
    inc edi                     ; (1)
@@:
    inc edi                     ; (1) 
    mov ecx,0CCCCCCCDh          ; (1)
    ; This algorithm obviously favours smaller values,
    ; but can be easily reversed to favour big values
    cmp eax,10                  ; (1)
    jb cont                     ; (1)
    inc edi                     ; (1)
    cmp eax,100                 ; (1) 
    jb cont                     ; (1)
    inc edi                     ; (1)
    cmp eax,1000                ; (1)
    jb cont                     ; (1)
    inc edi                     ; (1)
    cmp eax,10000               ; (1)
    jb cont                     ; (1)
    inc edi                     ; (1)
    cmp eax,100000              ; (1)
    jb cont                     ; (1)
    inc edi                     ; (1)
    cmp eax,1000000             ; (1)
    jb cont                     ; (1)    
    inc edi                     ; (1)
    cmp eax,10000000            ; (1)
    jb cont                     ; (1)
    inc edi                     ; (1)
    cmp eax,100000000           ; (1)
    jb cont                     ; (1)
    inc edi                     ; (1)
    cmp eax,1000000000          ; (1)
    jb cont                     ; (1)
    inc edi                     ; (1)
cont:
    ; This will add a total of 4 (?) zero bytes to the end of the
    ; string that must be allowed for when allocating the buffer.
    mov dword ptr [edi],0       ; (1)
lp:
    mov ebx,eax                 ; (1) 
    mul ecx                     ; (10)
    shr edx,3                   ; (1)
    mov eax,edx                 ; (1)
    lea edx,[edx*4+edx]         ; (1)
    shl edx,1                   ; (1)
    sub ebx,edx                 ; (1)
    or ebx,30h                  ; (1)
    ; This is the decrease which I said eliminates
    ; the need to have a reversing loop at last.
    dec edi                     ; (1)
    mov byte ptr [edi],bl       ; (1)       
    or eax,eax                  ; (1)    
    jnz lp                      ; (1) 
    pop edi                     ; (1)
    pop esi                     ; (1)
    pop ebx                     ; (1)
    ret                         ; (2)
dw2asc endp

; #########################################################################

end start
